<template>
  <view-list
    v-on:model-reload="loadList"
    v-on:export-csv="downloadCsv"
    v-on:model-search="search($event.query, $event.field)"
    :status="status"
    title="Operacje do potwierdzenia"
    :button="false"
    :length="rawData.length"
  >
    <RecycleScroller :items="rawData" :item-size="143">
      <template v-slot="{ item }">
        <action-list-item
          v-bind="item"
          v-on:model-reload="loadList"
          :isAction="true"
        />
      </template>
    </RecycleScroller>
  </view-list>
</template>

<script lang="ts">
import { Options } from "vue-class-component";

import ViewList from "@/views/list-views/ViewList.vue";
import ActionListItem from "@/components/list/custom/ActionListItem.vue";

import { ActionData, CsvDownload } from "@/interfaces";
import RecordList from "@/views/list-views/RecordList";
import { NApi } from "@/interfaces/connector";

@Options({
  components: {
    ViewList,
    ActionListItem,
  },
})
export default class ToBeAccepted extends RecordList<ActionData> {
  public API_CALL = NApi.getUnacceptedActions;

  filter(): void {
    1 == 1;
  }

  async downloadCsv() {
    await new CsvDownload(" ; ").download(this.rawData);
  }

  async onLoaded(data: ActionData[]) {
    this.rawData = data;
  }
}
</script>
